<?php
/**
 * @version		0.9.x
 * @package		mod_spncbrcur
 * @author		Sergey Kuznetsov http://www.seoprosto.net
 * @copyright	Copyright (c) 2017 SeoProsto.Net. All rights reserved.
 * @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
 */
defined('_JEXEC') or die;

class modspncbrcur {
	//public $timeout=3000;
	//public $reqcachetime=30;
	//public $viewnotavailable=false;
	function GetCursOnDate(){
		$wsdl = 'http://www.cbr.ru/DailyInfoWebServ/DailyInfo.asmx?WSDL';
		$acc=array();
		
		$date = JFactory::getDate('UTC');
		$cd = $date->format('Y-m-d H:i:s', true, false);
		$startdt= $date->format('Y-m-d', true, false).' 00:00:00';
		$db=JFactory::getDBO();
		$query = $db->getQuery(true);
		$query->select('*')->from('#__spncbrcur')->where("reqtype = 1 and startdt = '".$startdt."'");
		$db->setQuery($query,0,1);
		$result=$db->loadObjectList();
		if (count($result) > 0){
			$cw=$result[0]->courses;
			$acc=json_decode($cw,true);
		}
		else {
			try {
				$cbr = new SoapClient($wsdl,array('soap_version'=> SOAP_1_2, 'exceptions'=>true));
				$date = $cbr->GetLatestDateTime();
				$result = $cbr->GetCursOnDateXML(array('On_date'=>$date->GetLatestDateTimeResult)); 
				if ($result->GetCursOnDateXMLResult->any) {
					$xml = new SimpleXMLElement($result->GetCursOnDateXMLResult->any);
					foreach ($xml->ValuteCursOnDate as $cur) {
						$acc[$cur->VchCode->__toString()]=array('VchCode'=>$cur->VchCode->__toString(),'Vcode'=>$cur->Vcode->__toString(),
							'Vnom'=>$cur->Vnom->__toString(),'Vcurs'=>$cur->Vcurs->__toString(),
							'Vname'=>$cur->Vname->__toString());
					}
					$acc['RUB']=array('VchCode'=>'RUB','Vcode'=>'810','Vnom'=>'1','Vcurs'=>'1',
						'Vname'=>JText::_("MOD_SPNCBRCUR_RUB"));
					//
					$cw=json_encode($acc);
					$query = $db->getQuery(true);
					$query->insert('#__spncbrcur')
					->columns(
							array(
									$db->quoteName('setdt'), $db->quoteName('startdt'),
									$db->quoteName('reqtype'),$db->quoteName('courses')
							)
						)
						->values( $db->quote($cd). ',' .$db->quote($startdt). ','.'1' .','.$db->quote($cw));
					$db->setQuery($query);
					try {
						$db->execute();
					}
					catch (RuntimeException $e){
						$this->setError($e->getMessage());
						//jexit($e->getMessage());
						return false;
					} 
				}
				else echo 'Error!';
			}
			catch (SoapFault $e) { 
				JFactory::getApplication()->enqueueMessage(JText::_('MOD_SPNCBRCUR_SERVER_NOT_AVAILABLE'), 'warning');
				return false;
			}
		}
		return $acc;
	}
}

